package config

import (
	"gitea.pena/PenaSide/common/mongo"
	"github.com/caarlos0/env/v8"
	"github.com/joho/godotenv"
)

type Config struct {
	TelegramToken               string `env:"TELEGRAM_TOKEN,required"`
	TelegramChannelID           int64  `env:"TELEGRAM_CHANNEL_ID,required"`
	ClientHttpURL               string `env:"CLIENT_HTTP_URL,required"`
	AdminHttpURL                string `env:"ADMIN_HTTP_URL,required"`
	S3Endpoint                  string `env:"S3_ENDPOINT,required"`
	S3AccessKey                 string `env:"S3_ACCESS_KEY,required"`
	S3SecretKey                 string `env:"S3_SECRET_KEY,required"`
	S3Folder                    string `env:"S3_FOLDER,required"`
	S3FileUrl                   string `env:"S3_FILE_URL,required"`
	CustomerMicroserviceRPCURL  string `env:"CUSTOMER_MICROSERVICE_RPC_URL,required"`
	TrashLogHost                string `env:"TRASH_LOG_HOST,required"`
	// TODO: совсем непонятное название. эта штука собой представляет домен, админки стейджинга или прода в зависимости от того, со стейджинга или с прода пришла заявка и нужен только для формирования удобного для админа сообщения в телегу
	VerificationMicroserviceURL string `env:"VERIFICATION_MICROSERVICE_URL,required"`
	ExternalCfg                 External
}

type External struct {
	Database mongo.Configuration
}

func NewConfig(file ...string) (*Config, error) {
	if err := godotenv.Load(file...); err != nil {
		return nil, err
	}

	var cfg Config
	if err := env.Parse(&cfg); err != nil {
		return nil, err
	}

	return &cfg, nil
}

const ModuleLogger = "verification"
