package initialize

import (
	"gitea.pena/PenaSide/verification/internal/client"
	"gitea.pena/PenaSide/verification/internal/controllers/admin"
	"gitea.pena/PenaSide/verification/internal/controllers/user"
	"gitea.pena/PenaSide/customer/pkg/customer_clients"
)

type Controllers struct {
	VerificationAdmin *admin.VerifyAdminController
	VerificationUser  *user.VerifyUserController
}

func NewControllers(reps *Repositories, telegram *client.Telegram, customer *customer_clients.CustomersClient) *Controllers {
	return &Controllers{
		VerificationAdmin: admin.NewVerificationAdminController(admin.VerifyAdminControllerDeps{
			Repository: reps.Verification,
			Customer:   customer,
		}),
		VerificationUser: user.NewVerificationUserController(user.VerifyUserControllerDeps{
			Repository: reps.Verification,
			Telegram:   telegram,
		}),
	}
}
