package models

import "time"

type ReqUpdateVerificationStatus struct {
	Status string `json:"status"`
}

type RespUpdateVerificationStatus struct {
	Id     string `json:"_id"`
	UserId string `json:"userId"`
	Name   struct {
		Firstname  string `json:"firstname"`
		Secondname string `json:"secondname"`
		Lastname   string `json:"lastname"`
		Orgname    string `json:"orgname"`
	} `json:"name"`
	Cart   []string `json:"cart"`
	Wallet struct {
		Currency        string `json:"currency"`
		Cash            int    `json:"cash"`
		PurchasesAmount int    `json:"purchasesAmount"`
		Spent           int    `json:"spent"`
		Money           int    `json:"money"`
	} `json:"wallet"`
	Status    string    `json:"status"`
	Deleted   bool      `json:"deleted"`
	CreatedAt time.Time `json:"createdAt"`
	UpdatedAt time.Time `json:"updatedAt"`
	DeletedAt time.Time `json:"deletedAt"`
}

type RespUpdateVerificationStatusError struct {
	StatusCode int    `json:"statusCode"`
	Message    string `json:"message"`
}
