package models

import "time"

type Verification struct {
	ID        string             `json:"_id" bson:"_id,omitempty"`
	UserID    string             `json:"userID" bson:"user_id,omitempty"`
	Accepted  bool               `json:"accepted" bson:"accepted"`
	Status    string             `json:"status" bson:"status,omitempty"`
	UpdatedAt time.Time          `json:"updated_at" bson:"updated_at"`
	Comment   string             `json:"comment" bson:"comment,omitempty"`
	Files     []VerificationFile `json:"files" bson:"files,omitempty"`
	TaxNumber string             `json:"taxnumber" bson:"taxnumber,omitempty"`
}

type VerificationFile struct {
	Name string `json:"name" bson:"name"`
	Url  string `json:"url" bson:"url"`
}

type VerificationUpdate struct {
	Accepted  bool               `json:"accepted" bson:"accepted"`
	Status    string             `json:"status" bson:"status,omitempty"`
	UpdatedAt time.Time          `json:"updated_at" bson:"updated_at"`
	Comment   string             `json:"comment" bson:"comment,omitempty"`
	Files     []VerificationFile `json:"files" bson:"files,omitempty"`
	TaxNumber string             `json:"taxnumber" bson:"taxnumber,omitempty"`
}
